/*=============================================================================
vitalnix/accdb - User Management Suite - Unified Account Database
shared.c - Shared functions for the ACCDB system utilities
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003
  -- License restrictions apply (Dual FAL/GPL2).
  -- For details see doc/FAL.txt and doc/GPL2.txt.
=============================================================================*/
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <libHX.h>
#include "sysprog/shared.h"
#define MAXLNLEN 1024 /* max length for line buffer */

typedef unsigned char byte;

//-----------------------------------------------------------------------------
void p_interactive(const void **qtabp) {
  char buf[MAXLNLEN];

  while(*qtabp != NULL) {
    const char *fmt, *type = strrchr(fmt = *qtabp++, '%') + 1;

    if(*type == 's') {
      char **ptr = (void *)*qtabp++;
      printf(fmt, (*ptr != NULL) ? *ptr : "");
      fgets(buf, MAXLNLEN, stdin);
      HX_chomp(buf);
      if(strlen(buf) > 0) { HX_strclone(ptr, buf); }
    } else if(*type == 'd') {
      int *ptr = (void *)*qtabp++;
      printf(fmt, (ptr != NULL) ? *ptr : 0);
      fgets(buf, MAXLNLEN, stdin);
      HX_chomp(buf);
      if(strlen(buf) > 0) { *ptr = strtol(buf, NULL, 0); }
    }
  }

  return;
}

//==[ End of file ]============================================================
